<?php


namespace Drupal\xtc\Entity;


use Drupal\xtc\XtendedContent\API\XtcLoaderHandler;
use Drupal\xtc\XtendedContent\API\XtcLoaderProfile;
use Drupal\xtcguzzle\Plugin\XtcHandler\GuzzleBase;

class XtendedGuzzleTypeListBuilder extends XtcContentEntityTypeListBuilderBase {

  /**
   * Loads entities of this type from storage for listing.
   *
   * This allows the implementation to manipulate the listing, like filtering or
   * sorting the loaded entities.
   *
   * @return \Drupal\Core\Entity\EntityInterface[]
   *   An array of entities implementing \Drupal\Core\Entity\EntityInterface
   *   indexed by their IDs. Returns an empty array if no matching entities are
   *   found.
   */
  public function load() {
    $list = XtcLoaderProfile::getList();
    $id = 0;
    $types = $this->getTypes();
    foreach ($list as $name => $values) {
      $type = $values['type'] . '_' . $values['verb'];
      if (in_array($type, $types)) {
        $entity = New XtendedGuzzle($values, 'xtendedguzzle',$name);
        $entity->set('xtendedguzzle_id', $id);
        $entity->set('title', $values['label']);
        $entity->set('type', $name);
        $profiles[$name] = $entity;
      }
      $id++;
    }
    return $profiles;
  }

  protected function getTypes() {
    $plugins = [];
    $list = XtcLoaderHandler::getList();
    foreach ($list as $name => $values){
      $plugin = XtcLoaderHandler::get($name);
      if($plugin instanceof GuzzleBase){
        $plugins[] = $name;
      }
    }
    return $plugins;
  }

}
